/* scrivere un programma C per la gestione delle 
code presso un ufficio postale.
 Ogni persona  che viene inserita in coda e'
 caratterizzata dai seguenti dati: codice fiscale
 e tipo di operzione
 Una persona e' inserita una delle 4 code sulla
  base del tipo di operazione.
 Scrivere un menu' con le seguenti operazioni
 1) inserimento in una delle code
 2) eliminazione da una delle code
 3) visualizzazione di una coda
 Liberare la memoria al termine dell'esecuzione*/
 
 #include <stdio.h>
 
 struct pers {
        char codfisc[17];
        int tipo;
        };
 typedef struct pers tpers;
       
struct atomo { 
       struct pers dato;
       struct atomo *next;
       };
struct coda {
       struct atomo *primo,*ultimo;
       };
       
typedef struct coda tcoda;
       
void in_coda(tcoda *Q, tpers x)
{
  struct atomo *aux;
  
  aux=malloc(sizeof(struct atomo));
  if(aux==NULL)
    return;
  aux->dato=x;
  aux->next=NULL;  
  if(Q->primo==NULL) /* se la coda e' vuota*/
     Q->primo=aux;
  else Q->ultimo->next=aux;
  Q->ultimo=aux;
  
}

void out_coda(tcoda *Q)
{
     struct atomo *aux;
     
     if(Q->primo==NULL)
      {printf("Coda vuota\n");
       return;
      }
     aux=Q->primo;
     Q->primo=aux->next;
     free(aux);
     if(Q->primo==NULL) /* se la coda e' diventata vuota*/
        Q->ultimo=NULL;
}

void visualizza(tcoda Q)
{
     struct atomo *l;
     
     l=Q.primo;
     while(l!=NULL)
       {
         printf("%s\n",l->dato.codfisc);
         l=l->next;
       }
}

main() {
      tcoda VQ[4];
      tpers x;
      int scelta,i;
      
      /* inizializzazione code */
       for(i=0;i<4;i++)
        {
           VQ[i].primo=NULL;
           VQ[i].ultimo=NULL;
        }
        
       do {
           printf("\nScegli tra\n");
           printf("1) in coda\n2) out coda\n");
           printf("3) visualizza\n0) fine\n\n");
           scanf("%d",&scelta);
           switch(scelta) {
           case 1:  printf("Cod. fiscale ");
                    scanf("%s",x.codfisc);
                    do{
                    printf("Tipo operazione (0=cc, 1= racc, 2= bancoposta, 3=altro) ");
                    scanf("%d",&x.tipo);
                    i=x.tipo;
                    } while (i<0 || i>3);
                    /* inserimento nella coda di indice i*/
                    in_coda(&VQ[i],x);
                    break;
           case 2:  printf("Tipo operazione (0=cc, 1= racc, 2= bancoposta, 3=altro) ");
                    scanf("%d",&i);
                    /* eliminazione del primo elemento 
                       dalla coda di indice i*/
                    out_coda( &VQ[i]);
                    break;
           case 3:  printf("Tipo operazione (0=cc, 1= racc, 2= bancoposta, 3=altro) ");
                    scanf("%d",&i);
                    visualizza(VQ[i]);
                    break;
           default:; }
           } while(scelta!=0);
           
           /* liberazione della memoria  delle code*/
           for(i=0;i<4;i++)
             while(VQ[i].primo!=NULL)
              /* fino a quando la coda VQ di indice i
                 non e' vuota */
                 out_coda(&VQ[i]);
}                    
