#include <stdlib.h>
#include <stdio.h>

struct esame {
       long matricola;
       int voto,materia;
       };
struct atomo {
       struct esame dato;
       struct atomo *next;
       };
       
void visualizza(struct atomo *testa)
{
     struct atomo *l;
     
     /* visualizzazione una lista di esami*/
     l=testa;
     while(l!=NULL)
      {
        printf("Matricola: %ld\n",l->dato.matricola);
        printf("Voto: %d\n",l->dato.voto);
        l=l->next;
      }
}

void ricerca(struct atomo *testa, long matricola)
{
     struct atomo *l;
     /* ricerca in una lista */
     l=testa;
     while(l!=NULL)
       if(l->dato.matricola==matricola)
         { printf("Trovato\n");
           return;
         }
        else l=l->next;
     
     printf("Non trovato\n");
}        

void ins_ordinato(struct atomo **testa, struct esame x)
{
      struct atomo *l1,*l2,*aux;
     
     
     aux=malloc(sizeof(struct atomo));
     if(aux==NULL)
        { printf("memoria non allocata\n");
          return;
        }
        
     aux->dato=x;
     if(*testa==NULL || x.matricola < (*testa)->dato.matricola)
     /* inserimento in testa */
      {
        aux->next=*testa;
        *testa=aux;
        return;
      }
      
      /* inserimento in pos. successiva alla prima*/
     l1=(*testa)->next;
     l2=*testa;
     while(l1!=NULL)
       if(x.matricola < l1->dato.matricola)
          break;
       else { l1=l1->next;
              l2=l2->next;
              }
        l2->next=aux;
      aux->next=l1;
}




main() {
       struct atomo *lista[10];
       struct esame x;
       int i,scelta;
       struct atomo *aux;
       long matricola;
       
       
       /* inizializzazione delle  liste*/
        for(i=0;i<10;i++)
         lista[i]=NULL;
         
        do {
           printf("\nScegli tra\n");
           printf("1) Inserimento ordinato\n");
           printf("2) Visualizzazione di una lista\n");
           printf("3) Ricerca in una lista\n");
           printf("0) fine\n\n");
           scanf("%d",&scelta);
           switch(scelta) {
             case 1:    /* inserimento ordinato*/
                         /* lettura dell'elemento da inserire */
                          printf("Matricola ");
                          scanf("%ld",&x.matricola);
                          printf("Voto ");
                          scanf("%d",&x.voto);
                          printf("Codice materia (0..9) ");
                          scanf("%d",&x.materia);
                          i=x.materia;
                          ins_ordinato(&lista[i],x);
                          break;
              case 2:     /* visualizzazione*/
                          printf("Ins. codice materia (0..9) ");
                          scanf("%d",&i);
                          visualizza(lista[i]);
                          break;
              case 3:     /* ricerca */
                          printf("Ins- codice materia (0..9) ");
                          scanf("%d",&i);
                          printf("Matricola ");
                          scanf("%ld",&matricola);
                          ricerca(lista[i],matricola);
                          break;
              default:;  }
              } while(scelta!=0);
              
             /* liberazione della memoria */
               for(i=0;i<10;i++)
                while(lista[i]!=NULL)
                  {
                    aux=lista[i];
                    lista[i]=lista[i]->next;
                    free(aux);
                  }
}
       
       


     
